#ifndef __CRC_INFO_H
#define	__CRC_INFO_H

#include "game.h"

#include <string>
#include <set>

string token_get(const string& s, int& ptr, const char* sep);
void token_skip(const string& s, int& ptr, const char* sep);

extern "C" unsigned crc32(unsigned crc, const unsigned char* buf, unsigned len);

struct crc_info {
	unsigned crc;
	mutable string description;
	mutable string year;
	mutable string manufacturer;

	bool operator<(const crc_info& A) const {
		return crc < A.crc;
	}
};

typedef set<crc_info> crc_info_set;

struct crc_list {
	string name;
	mutable crc_info_set bag;

	bool operator<(const crc_list& A) const {
		return name < A.name;
	}
};

typedef set<crc_list> crc_list_set;

void crc_scan(crc_list_set& cls, const game_set& gs, const string& crc_dir);

#endif
