/*
 * This file is part of the AdvanceMAME project
 *
 * Copyright (C) 1999-2000 Andrea Mazzoleni
 *
 * The contents of this file are free for non-commercial use.
 * Any commercial use is forbidden.
 */

#ifndef __SCRSTD_H
#define __SCRSTD_H

#include <stdarg.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Fast call */
#ifndef FAST
#define FAST
#endif

typedef unsigned char uint8;
typedef signed char int8;
typedef unsigned short uint16;
typedef signed short int16;
typedef unsigned int uint32;
typedef signed int int32;

typedef struct video_color_struct {
	uint8 blue __attribute__ ((packed));
	uint8 green __attribute__ ((packed));
	uint8 red __attribute__ ((packed));
	uint8 alpha __attribute__ ((packed));
} video_color;

/* Memory alignement */
#if defined( __pentiumpro )
#define ALIGN_BIT 3
#define ALIGN_UNCHAINED_BIT 4
#else
#define ALIGN_BIT 2
#define ALIGN_UNCHAINED_BIT 4
#endif
#define ALIGN (1U << ALIGN_BIT)
#define ALIGN_MASK (ALIGN - 1U)
#define ALIGN_UNCHAINED (1U << ALIGN_UNCHAINED_BIT)
#define ALIGN_UNCHAINED_MASK (ALIGN_UNCHAINED - 1U)

void video_error_description_set(const char* error,...);
void video_log(const char *text, ...);
void video_log_va(const char *text, va_list arg);

#ifdef __cplusplus
}
#endif

#endif
